#!/usr/bin/python
# Copyright 2018,2019,2020 Shun Sakuraba
#
# Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:
#
# 1. Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
#
# 2. Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
#
# 3. Neither the name of the copyright holder nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

# This script runs on python 2.7. Also tested on python3 but not sure whether it runs perfectly.
# Why not python 3 on 2018? Because 3 may not be installed on some supercomputer centers. Heck.

import argparse
import sys
import collections
import copy

def cmp_(x, y):
    return (x > y) - (x < y) # cmp deprecated in Python3!

def parse_args():
    parser = argparse.ArgumentParser(description="""Add part of charges into REST2 region to keep charge neutrality during REST2.
    Input topology must be preprocessed topology (generated by gmx grompp -pp). Also the atom types you want to scale with REST2 must be appended with "_". See PLUMED2's partial_tempering module for details.
    """)
    parser.add_argument('topology', action='store', type=str, 
                        help='Topology file (must be preprocessed and underlined)')
    parser.add_argument('output', action='store', type=str, 
                        help='Topology file output')
    parser.add_argument('--ions', action='store', type=str, default="Na,NA,K,Ca,CA,F,Cl,CL,Br,BR,I,IP,IM",
                        help='Name of molecules that are considered as ions')
    parser.add_argument('--suffix', action='store', type=str, default="_", 
                                    help='Suffix character')
    parser.add_argument('--mol-suffix', action='store', type=str, default="0", 
                                    help='Suffix to be appended for newly ')
    parser.add_argument('--allow-noninteger', action='store_true', 
                                    help='Allow non-integer perturbed charges')

    args = parser.parse_args()
    return args

def scan_topology(topfile, suffix):
    with open(topfile) as fh:
        bondtype_of_atomtype = {}
        atomtype_info = {}
        dummy_atomtypes = set()
        dihtype = {}
        molecule = None
        sectiontype = None
        header = []
        mol_charge_info = collections.OrderedDict()
        systemname = None
        molecules = []
        cur_chunk = []
        MOLINFO = 0
        CHARGE = 1
        charge_sums = None

        def store_chunk(chunk):
            if sectiontype is None or sectiontype in ["defaults", 
                    "atomtypes", "bondtypes", "pairtypes", "angletypes", "dihedraltypes", "constrainttypes",
                    "nonbond_params", "implicit_genborn_params"]:
                header.append((sectiontype, chunk))
            elif sectiontype in ["moleculetype", "atoms", 
                    "bonds", "pairs", "pairs_nb", "angles", "dihedrals", "exclusions", "constraints", "settles"] or \
                            sectiontype.startswith("virtual_sites") or \
                            sectiontype.endswith("_restraints") or \
                            sectiontype == "angle_restraints_z":
                mol_charge_info[molecule][MOLINFO].append((sectiontype, chunk))
                mol_charge_info[molecule][CHARGE] = charge_sums
            elif sectiontype in ["system", "molecules"]:
                # nothing to do here
                pass
            else:
                raise RuntimeError("Unsupported section type: " + sectiontype)

        for lraw in fh:
            lraws = [lraw]
            while lraw.endswith("\\\n"):
                lraws.append(next(fh)) # because cmaptypes are unused in this scripts
            ltmp = lraw.split(';', 1)
            if len(ltmp) == 1:
                l = ltmp[0]
                comment = ""
            else:
                l = ltmp[0]
                comment = ";" + ltmp[1]
            l = l.strip()
            ls = l.split()
            if l.startswith('#'):
                sys.stderr.write("The topology file is not preprocessed")
                sys.exit(1)
            if l.startswith('['):
                # new chunk begins: store current one
                store_chunk(cur_chunk)
                cur_chunk = []
                sectiontype = ls[1]
                continue
            cur_chunk.append(lraws)

            # blank line
            if len(ls) == 0:
                continue

            if sectiontype is None:
                continue # ignored as comment
            elif sectiontype == 'atomtypes':
                # atomtype section needs parsing in case [ atoms ] do not have charge
                if len(ls) < 6:
                    raise RuntimeError("Atomtype contains < 6 fields")
                # here everything is mess but toppush.cpp is actually super mess 
                if len(ls[5]) == 1 and ls[5][0].isalpha():
                    have_bonded_type = True
                    have_atomic_number = True
                elif len(ls[3]) == 1 and ls[3][0].isalpha():
                    have_bonded_type = False
                    have_atomic_number = False
                else:
                    have_bonded_type = ls[1][0].isalpha()
                    have_atomic_number = not have_bonded_type

                atomtype = ls[0]
                (mass, charge, _particle, _sigc6, _epsc12) = ls[1 + int(have_bonded_type) + int(have_atomic_number):]

                mass = float(mass)
                charge = float(charge)

                atomtype_info[atomtype] = (charge, mass)

                # and the original line is also appended after this big if-elif-else block
            elif sectiontype == 'moleculetype':
                molecule = ls[0]
                # These None are sentinels for 1-origin access
                scaled = [None]
                charge_sums = { (k, st): 0.0 for k in ["ALL", "REST2"] for st in ["A", "B"] }
                mol_charge_info[molecule] = [[], None]
            elif sectiontype == 'atoms':
                aindex = int(ls[0])
                atomtype = ls[1]
                # remove suffix to store atomname
                is_scaled = atomtype.endswith(args.suffix)
                if is_scaled:
                    canonical_atomtype = atomtype[:-len(args.suffix)]
                else:
                    canonical_atomtype = atomtype
                assert(aindex == len(scaled))
                scaled.append(is_scaled)

                # charge & mass is optional parameters, oof...
                if len(ls) > 6:
                    charge = float(ls[6])
                else:
                    (charge, _) = atomtype_info[canonical_atomtype]
                if len(ls) > 7:
                    mass = float(ls[7])
                else:
                    (_, mass) = atomtype_info[canonical_atomtype]
                if len(ls) > 8:
                    atomtypeB = ls[8]
                    if atomtypeB.endswith(args.suffix):
                        sys.stderr.write("Warning: typeB in atom line should not be suffixed (molecule %s, atom index %d)\n" % (molecule, aindex))
                    (chargeB, massB) = atomtype_info[atomtypeB]
                    fep = True
                    if is_scaled and not atomtypeB.endswith(args.suffix):
                        atomtypeB += args.suffix
                else:
                    fep = False
                    chargeB = charge # copy
                    massB = mass
                    atomtypeB = atomtype
                if len(ls) > 9:
                    chargeB = float(ls[9])
                if len(ls) > 10:
                    massB = float(ls[10])

                charge_sums[("ALL", "A")] += charge
                charge_sums[("ALL", "B")] += chargeB
                if is_scaled:
                    charge_sums[("REST2", "A")] += charge
                    charge_sums[("REST2", "B")] += chargeB
            elif sectiontype == 'system':
                systemname = l
            elif sectiontype == 'molecules':
                molecules.append((ls[0], int(ls[1])))

    return (header, mol_charge_info, systemname, molecules)

def generate_suffixed(target_mollines, newmolname, suffix):
    ret = []
    for sectiontype, linesblock in target_mollines:
        if sectiontype in ['moleculetype', 'atoms']:
            msec = []
            for lines in linesblock:
                l = " ".join(lines)
                ltmp = l.split(';')[0]
                ls = ltmp.split()
                if ls != []:
                    if sectiontype == 'moleculetype':
                        ls[0] = newmolname
                        msec.append([" ".join(ls) + "\n"])
                    elif sectiontype == 'atoms':
                        ls[1] += suffix
                        msec.append([" ".join(ls) + "\n"])
                else:
                    msec.append(lines)
            ret.append((sectiontype, msec))
    return ret

def update_molecules(mol_charge_info, molecules, ions, suffix, molsuffix, allow_noninteger):
    MOLINFO = 0
    CHARGE = 1
    totrestcharge = 0.
    totrestchargeB = 0.
    sys.stdout.write("%-25s %6s %12s\n" % ("Molecule", "N", "Charge"))
    sys.stdout.write("------\n")
    for (m, n) in molecules:
        molcharge = mol_charge_info[m][CHARGE]
        # add up total charges
        totrestcharge += molcharge[("REST2", "A")] * n
        totrestchargeB += molcharge[("REST2", "B")] * n
        sys.stdout.write("%-25s %6d %12.6f\n" % (m, n, molcharge[("REST2", "A")]))
    if abs(totrestcharge - totrestchargeB) > 1e-3:
        # Charge Mismatch
        raise RuntimeError("total REST2-perturbed charges should be identical between A and B states")

    if abs(totrestcharge - round(totrestcharge)) > 1e-3:
        if not allow_noninteger:
            raise RuntimeError("REST2 perturbed charge is noninteger")
    else:
        totrestcharge = round(totrestcharge)
    
    sys.stdout.write("------\n")
    sys.stdout.write("Total REST2 perturbed charges: %.6f\n" % totrestcharge)
    if abs(totrestcharge) < 1e-2:
        sys.stdout.write("No perturbation performed")
        return
    
    totrestsign = cmp_(totrestcharge, 0.)
    assert totrestsign in [1, -1]
    # Find target ions to perturb
    # The molecule should:
    # 1) appear in "molecules" section
    # 2) have an opposite sign to total perturbation
    # 3) have the smallest possible charge per atom in abs
    eligible = []
    for (m, n) in molecules:
        if m not in ions:
            continue
        molchargemap = mol_charge_info[m][CHARGE]
        molcharge = molchargemap[("ALL", "A")]
        molsign = cmp_(molcharge, 0.)
        if totrestsign != -molsign:
            continue
        eligible.append((abs(molcharge), n, m))

    if eligible == []:
        raise RuntimeError("No appropriate ions exist: no opposite sign charges exist")

    eligible.sort()
    target = None
    target_molcharge = None
    for (_abscharge, n, m) in eligible:
        molchargemap = mol_charge_info[m][CHARGE]
        molcharge = molchargemap[("ALL", "A")]
        if abs(molcharge * n) > abs(totrestsign):
            target = m
            target_molcharge = molcharge
            break

    if target is None:
        raise RuntimeError("No appropriate ions exist: number of molecules are insufficient")

    sys.stdout.write("Going to perturb \"%s\"\n" % target)
    nperturb = round(-totrestcharge / molcharge)
    sys.stdout.write("Perturb %d molecules\n" % nperturb)
    newmolname = target + molsuffix

    new_target_info = generate_suffixed(mol_charge_info[target][MOLINFO], newmolname, suffix)
    ret_mol_charge = collections.OrderedDict()
    for m in mol_charge_info:
        ret_mol_charge[m] = mol_charge_info[m]
        if m == target:
            ret_mol_charge[newmolname] = [new_target_info, None]
    newmolecules = []
    for (m, n) in molecules:
        if m == target:
            assert n > nperturb
            newmolecules.append((newmolname, nperturb))
            newmolecules.append((m, n - nperturb))
        else:
            newmolecules.append((m, n))
    sys.stdout.write("New topology generated\n")

    return (ret_mol_charge, newmolecules)

def write_topology(outfile, header, mol_charge_info, systemname, molecules):
    sys.stdout.write("Writing topology\n")
    with open(outfile, "w") as ofh:
        for (sectiontype, payload) in header:
            if sectiontype is not None:
                ofh.write("[ %s ]\n" % sectiontype)
            for lines in payload:
                for l in lines:
                    ofh.write(l)
        for m, [chunk, _] in mol_charge_info.items():
            for sectiontype, payload in chunk:
                ofh.write("[ %s ]\n" % sectiontype)
                for lines in payload:
                    for l in lines:
                        ofh.write(l)
        ofh.write("[ system ]\n%s\n" % systemname)
        ofh.write("[ molecules ]\n")
        for m, n in molecules:
            ofh.write("%-20s %6d\n" % (m, n))
    sys.stdout.write("Done\n")

def process_topology(topfile, outfile, ions, suffix, molsuffix, allow_noninteger):
    (header, mol_charge_info, systemname, molecules)  = scan_topology(topfile, suffix)
    mol_charge_info, molecules = update_molecules(mol_charge_info, molecules, ions.split(','), suffix, molsuffix, allow_noninteger)
    write_topology(outfile, header, mol_charge_info, systemname, molecules)

if __name__ == "__main__":
    args = parse_args()

    process_topology(args.topology, args.output, args.ions, args.suffix, args.mol_suffix, args.allow_noninteger)
